package com.dol9.db;

import java.io.BufferedReader;

import java.io.FileReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.MessageFormat;

public class Dol9DBQuery {
	static final String driver[] = { "oracle.jdbc.driver.OracleDriver",
			"com.microsoft.sqlserver.jdbc.SQLServerDriver",
			"com.mysql.jdbc.Driver" };
	public static boolean TEST_MODE;

	private String dbms;
	private String dbip;
	private String dbport;
	private String dbname;

	private Connection conn = null;
	private Statement stmt = null;
	private ResultSet rs = null;

	private int totalRows = 0;
	private int columnNum = 0;
	private static int loopCount = 0;

	private String[] columnName; // ڰ ɾ Է ʵ
	private String[] fcolumnName; // ڰ Ͽ Է ʵ

	public Dol9DBQuery(String mode, String dbms, String dbip, String dbport,
			String dbname) {
		if (mode.toUpperCase().equals("TRUE")) {
			TEST_MODE = true;
		} else if (mode.toUpperCase().equals("FALSE")) {
			TEST_MODE = false;
		}

		this.dbms = dbms;
		this.dbip = dbip;
		this.dbport = dbport;
		this.dbname = dbname;
	}

	public String toString() {
		if (this.dbms.equals("ORACLE"))
			return "jdbc:oracle:thin:@" + dbip + ":" + dbport + ":" + dbname;
		else if (this.dbms.equals("MSSQL"))
			return "jdbc:sqlserver://" + dbip + ":" + dbport + ";databaseName="
					+ dbname;
		else if (this.dbms.equals("MYSQL"))
			return "jdbc:mysql://" + dbip + ":" + dbport + "/" + dbname
					+ "?useUnicode=true&characterEncoding=euckr";
		else
			return "";
	}

	/**
	 * @param user
	 * @param passwd
	 * @return
	 * @throws ClassNotFoundException
	 */
	public boolean connect(String user, String passwd)
			throws ClassNotFoundException {
		if (dbms.toUpperCase().equals("ORACLE")) {
			Class.forName(driver[0]);
		} else if (dbms.toUpperCase().equals("MSSQL")) {
			Class.forName(driver[1]);
		} else if (dbms.toUpperCase().equals("MYSQL")) {
			Class.forName(driver[2]);
		}
		try {
			this.conn = DriverManager.getConnection(this.toString(), user,
					passwd);
			if (TEST_MODE) {
				System.out.println("Connection success");
			}
			this.stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
					ResultSet.CONCUR_READ_ONLY);

			if (TEST_MODE) {
				System.out.println("Create Statement success");
			}

			if (this.conn == null) {
				System.err.println("Connection object is null");
				close();
				System.exit(1);
			}
			if (this.stmt == null) {
				System.err.println("Statement object is null");
				close();
				System.exit(2);
			}
		} catch (SQLException e) {
			e.printStackTrace();
			close();
			System.exit(1);
		}
		return true;
	}

	// TODO  Ȯ sql ȿ ˻
	// TODO isValidSQL  DML °  ~ insert, udpate, delete
	public boolean isValidSql(String sql) {
		if (sql == null || sql.length() == 0) {
			return false;
		}

		sql = sql.toUpperCase();

		if (sql.startsWith("INSERT") || sql.startsWith("UPDATE")
				|| sql.startsWith("DELETE") || sql.startsWith("SELECT")) {
			;
		}
		return true;
	}

	public void close() {
		try {
			if (rs != null) {
				rs.close();
			}
			if (stmt != null) {
				stmt.close();
			}
			if (conn != null) {
				conn.close();
			}
		} catch (SQLException e) {
			e.printStackTrace();
			System.exit(9);
		}
	}

	public boolean run(String sql, String option, String path, int timeOut)
			throws Exception {
		try {
			stmt.setQueryTimeout(timeOut);
		} catch (Exception e) {
			e.printStackTrace();
			close();
			System.exit(4);
		}
		if (option.equals("-c") || option.equals("-f")) {
			this.selectQuery(sql);
			/*
			 * -unf ɼ ߰ Žð,  ϴ α   ùٿ ʵ  κп   ִ.
			 * ùٿ ʵ ϸ, ؽƮ ʵ Ÿ ִ° ϴ°  2010.11.09 by
			 * kgcrom
			 */
		} else if (option.equals("-u") || option.equals("-uf")
				|| option.equals("-unf")) {
			this.updateQuery(sql, option, path);
		} else if (option.equals("-d")) {
			this.deleteQuery(sql);
		}
		return true;
	}

	private boolean deleteQuery(String sql) {
		try {
			totalRows = stmt.executeUpdate(sql);
			if (TEST_MODE) {
				System.out.println("Delete success");
				System.out.println("delete query : " + sql);
			}
		} catch (Exception e) {
			e.printStackTrace();
			close();
			System.exit(5);
		}
		return true;
	}

	private boolean updateQuery(String sql, String option, String path)
			throws Exception {
		if (option.equals("-u")) {
			try {
				if (TEST_MODE) {
					System.out.println("no-File update");
					System.out.println("no-File update query :" + sql);
				}
				totalRows = stmt.executeUpdate(sql);
				
			} catch (SQLException e) {
				System.out.println("no-File update error");
				close();
				System.exit(6);
			}
		} else if (option.equals("-uf") || option.equals("-unf")) {
			conn.setAutoCommit(false);
			// PreparedStatement ps;
			try {
				BufferedReader br = new BufferedReader(new FileReader(path));
				String query = "";

				if (option.equals("-uf")) {
					String buf = br.readLine();
					query = regularSql(sql, buf, "valid");
				} else if (option.equals("-unf")) {
					query = regularSql(sql, "", "none");
				}

				query = query.replaceAll("\'", "\''");

				// System.out.println("query: end"+query);

				String rbuf;
				String[] fvalue;
				String exequery;

				while ((rbuf = br.readLine()) != null) {
					fvalue = rbuf.split("\t");
					exequery = MessageFormat.format(query, fvalue);
					stmt.execute(exequery);
				}
				conn.commit();
				if (TEST_MODE)
					System.out.println("File update Success");
			} catch (SQLException e) {
				e.printStackTrace();
				close();
				System.exit(7);
			}
		}
		return true;
	}

	/**
	 * @param sql
	 *            user input query ex)insert into dbtest values('<#id>;',
	 *            '<#name>;', '<#grade>;')
	 * @param buf
	 *            first Line to DB field name
	 * @return Process query ex) insert into dbtest values('1', 'ť',
	 *         '00111')
	 */
	private String regularSql(String sql, String buf, String status) {
		int beginfield = 0, endfield;
		int begintext, endtext;
		int idxNum;
		String inputfield;

		boolean existfield; // sql Է ʵ  쵵 Ƿ 
		int findfield;
		String makesql = "";

		if (status.equals("valid"))
			fcolumnName = buf.split("\t");
		else if (status.equals("none"))
			fcolumnName = null;

		begintext = beginfield;

		idxNum = 0;
		while (true) {
			beginfield = sql.indexOf("<#", beginfield);
			endtext = beginfield;

			if (beginfield == -1)
				break;
			endfield = sql.indexOf(">;", beginfield); // ڰ  ʵ ġ ã

			if (endfield == -1) {
				System.out.println("doesn't define '>;'");
				break;
			}

			makesql += sql.substring(begintext, endtext);

			inputfield = sql.substring(beginfield + 2, endfield);

			existfield = false;
			findfield = 0;

			// 2010.11.09 ߰
			if (status.equals("valid")) {
				for (String tmpField : fcolumnName) {
					if (inputfield.equals(tmpField)) {
						existfield = true;
						break;
					}
					findfield++;
				}
			} else if (status.equals("none")) {
				findfield = loopCount;
				loopCount++;
				existfield = true;
			}

			if (existfield == true) {
				makesql += "{" + findfield + "}";
				begintext = endfield + 2;
				idxNum++;
			} else {
				begintext = beginfield;
			}
			beginfield = endfield;
		}
		makesql += sql.substring(begintext, sql.length());

		return makesql;
	}

	private boolean selectQuery(String sql) {
		try {
			if (TEST_MODE) {
				System.out.println("select query :" + sql);
			}
			this.rs = stmt.executeQuery(sql);
			if (rs == null) {
				totalRows = 0;
			} else {
				rs.last();
				totalRows = rs.getRow();
				rs.beforeFirst();

				ResultSetMetaData rsm = rs.getMetaData();
				columnNum = rsm.getColumnCount();
				if (TEST_MODE) {
					System.out.println("OK");
					System.out.println(totalRows);
					System.out.println(columnNum);
				}
				columnName = new String[columnNum];
				for (int i = 1; i <= columnNum; i++) {
					columnName[i - 1] = rsm.getColumnName(i);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			close();
			System.exit(8);
		}
		return true;
	}

	public int getTotalRows() {
		return totalRows;
	}

	public int getColumn() {
		return this.columnNum;
	}

	public ResultSet getResult() {
		return this.rs;
	}

	public String[] getColumnName() {
		return this.columnName;
	}
}