package com.kcube.dbmanager;

import java.io.FileInputStream;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Properties;

import com.dol9.db.Dol9DBQuery;

public class DBManager2010 {
	static Properties conf;
	static Dol9DBQuery dbquery = null;

	String user;
	String passwd;

	private static BufferedWriter bw = null;
	public static String NEW_LINE = System.getProperty("line.separator");

	public DBManager2010(String config) throws IOException {
		FileInputStream fis = new FileInputStream(config);
		conf = new Properties();
		conf.load(new java.io.BufferedInputStream(fis));

		String dbkind = conf.getProperty("DB_KIND").toUpperCase();
		String dbip = conf.getProperty("DB_IP");
		String dbport = conf.getProperty("DB_PORT");
		String dbname = conf.getProperty("DB_NAME");
		user = conf.getProperty("USER");
		passwd = conf.getProperty("PW");

		dbquery = new Dol9DBQuery(conf.getProperty("TEST_MODE"), dbkind, dbip,
				dbport, dbname);

		try {
			dbquery.connect(user, passwd);
		} catch (ClassNotFoundException e) {
			System.out.println("Connection error");
			System.exit(1);
		}
	}

	public boolean runQuery(String _query, String _option, String _path)
			throws Exception {
		String query = "";
		String option = "";
		String path = "";

		int time_out = Integer.parseInt(conf.getProperty("TIME_OUT"));

		query = _query;
		option = _option.toLowerCase();
		path = _path;

		if (!dbquery.isValidSql(query)) {
			System.err.println("Query isn't valid");
			return false;
		}

		if (option.equals("-f")) // select DML & file output
		{
			try {
				bw = new BufferedWriter(new FileWriter(path));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}

			dbquery.run(query, option, path, time_out);
			try {
				this.printRows(true);
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else if (option.equals("-c")) // select DML & console output
		{
			dbquery.run(query, option, path, time_out);
			try {
				this.printRows(false);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		// update & insert & delete DML
		else if (option.equals("-u") || option.equals("-uf")
				||option.equals("-unf") || option.equals("-d"))
			try {
				dbquery.run(query, option, path, time_out);
			} catch (Exception e) {
				e.printStackTrace();
			}
		else // option ߸ Է
		{
			return false;
		}

		return true;
	}

	public boolean printRows(boolean FILE_MODE) throws IOException {

		int columnNum;
		// int totalRows;
		String value;
		String[] columnName;

		// totalRows = dbquery.getTotalRows();
		columnNum = dbquery.getColumn();
		columnName = dbquery.getColumnName();

		ResultSet rs = dbquery.getResult();

		if (FILE_MODE) {
			for (int i = 0; i < columnNum; i++) {
				bw.write(columnName[i]);

				if (i < columnNum - 1)
					bw.write('\t');
			}
			bw.write(NEW_LINE);

			try {
				while (rs.next()) {
					for (int i = 1; i <= columnNum; i++) {
						value = rs.getString(i);
						if (value != null) {
							bw.write(value.replaceAll("\t", " "));
						} else
							bw.write(" ");

						if (i < columnNum)
							bw.write('\t');
					}
					bw.write(NEW_LINE);
				}
			} catch (SQLException e) {
				e.printStackTrace();
				return false;
			}
		} else {
			for (int i = 0; i < columnNum; i++) {
				System.out.print(columnName[i]);

				if (i < columnNum - 1)
					System.out.print('\t');
			}
			System.out.println();

			try {
				while (rs.next()) {
					for (int i = 1; i <= columnNum; i++) {
						value = rs.getString(i);
						if (value != null) {
							System.out.print(value.replaceAll("\t", " "));
						} else
							System.out.print(" ");

						if (i < columnNum)
							System.out.print('\t');
					}
					System.out.println();
				}
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return true;
	}

	public static void main(String[] args) throws Exception {
		String configFile = args[0];
		String path;
		DBManager2010 manager = new DBManager2010(configFile);

		if (args.length != 4) {
			path = "";
		} else
			path = args[3];

		if (!manager.runQuery(args[1], args[2], path)) {
			System.err.println("runQuery method error");
		}

		if (bw != null)
			bw.close();

		dbquery.close();

		System.exit(0);
	}
}